// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.
var needToRestartGame=false;

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	setupParts();
	loadPreferences();
	initGames();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
	savePreferences();
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";
	savePreferences();
	
	if (needToRestartGame) {
		initGames();
		needToRestartGame=false;
	}
	
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function savePreferences() {

	// Values you provide
	nbColumns = document.getElementById("columnsPopup");	// replace with ID of popup
	// Popup code
	nbColumns = parseInt(nbColumns.object.getValue());
	// Values you provide
	nbColors = document.getElementById("colorsPopup");	// replace with ID of popup
	// Popup code
	nbColors = parseInt(nbColors.object.getValue());
	// Values you provide
	var mode = document.getElementById("modePopup");	// replace with ID of popup
	// Popup code
	mode = mode.object.getValue();
	if (mode=="Easy") {
		allowEmpty=false;
		allowDoubles=false;
	} else if (mode=="Normal") {
		allowEmpty=false;
		allowDoubles=true;
	} else if (mode=="Hard") {
		allowEmpty=true;
		allowDoubles=true;
	}
	
	// Values you provide
	var preferenceKey = "nbColors";		// replace with the key for a preference
	var preferenceValue = nbColors;	// replace with a preference to save
	// Preference code
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceKey);
	
	// Values you provide
	preferenceKey = "nbColumns";		// replace with the key for a preference
	preferenceValue = nbColumns;	// replace with a preference to save
	// Preference code
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceKey);
	
	// Values you provide
	preferenceKey = "mode";		// replace with the key for a preference
	preferenceValue = mode;	// replace with a preference to save
	// Preference code
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceKey);
	
	updateNbChoices();
}

function loadPreferences() {
	// Values you provide
	var preferenceForKey = "mode";	// replace with the key for a preference
	// Preference code
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	if (preferenceForKey) {
		var mode=preferenceForKey;
		if (mode=="Easy") {
			allowEmpty=false;
			allowDoubles=false;
		} else if (mode=="Normal") {
			allowEmpty=false;
			allowDoubles=true;
		} else {
			allowEmpty=true;
			allowDoubles=true;
		}
	}
	preferenceForKey = "nbColumns";	// replace with the key for a preference
	// Preference code
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	if (preferenceForKey) {
		nbColumns=parseInt(preferenceForKey);
	}
	
	preferenceForKey = "nbColors";	// replace with the key for a preference
	// Preference code
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	if (preferenceForKey) {
		nbColors=parseInt(preferenceForKey);
	}
	
	// Values you provide
	var popupToChange = document.getElementById("columnsPopup");	// replace with ID of popup
	var newPopupValue = nbColumns;								// string with option name to select
	// Popup code
	popupToChange.object.setValue(newPopupValue);	
	
	// Values you provide
	popupToChange = document.getElementById("colorsPopup");	// replace with ID of popup
	newPopupValue = nbColors;								// string with option name to select
	// Popup code
	popupToChange.object.setValue(newPopupValue);	

	// Values you provide
	popupToChange = document.getElementById("modePopup");	// replace with ID of popup
	newPopupValue = mode;								// string with option name to select
	// Popup code
	popupToChange.object.setValue(newPopupValue);	
	
	updateNbChoices();
}


function changeRules(event)
{
	needToRestartGame=true;
}

function updateNbChoices() {
	// Values you provide
	var textFieldToChange = document.getElementById("nbChoicesValue");	// replace with ID of text field
	var newTextFieldText = calculNbChoices();						// value to change range to
	// Text field code
	textFieldToChange.innerText = newTextFieldText;

}


function donateClicked(event)
{
    clicked("http://ismileys.free.fr/donate.html");
}


function iSmileysClicked(event)
{
    clicked("http://ismileys.free.fr");
}
