var version="1.0";
var version_re= /version=(.+?)$/;
var beta_v_re = /.*\a\d*$/;

var isIphone=false;

isIphone=navigator.userAgent.indexOf("iPhone") != -1;

var grid;
var win=false;

var nbColumns=5;

var nbColors=10;

var nbRows=10;

var allowEmpty=false;

var allowDoubles=false;

var currentLine=0;

/**
 *   Array convenience method to check for membership.
 *
 *   @param object element
 *   @returns boolean
 */
Array.prototype.contains = function (element) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == element) {
            return true;
        }
    }
    return false;
};

Array.prototype.insertAt = function (what, iIndex) {
	if (iIndex < this.length) {
		var aAfter = this.splice(iIndex, 100000, what);
		for (var i = 0; i < aAfter.length; i++) {
			this.push(aAfter[i]);
		}
	} else {
		this.push(what);
	}
}

Array.prototype.getIndex = function (element) {
	//alert("coucou");
    for (var i = 0; i < this.length; i++) {
        if (this[i] == element) {
            return i;
        }
    }
    return -1;
};

/**
 *   Array convenience method to clear membership.
 *
 *   @param object element
 *   @returns void
 */
Array.prototype.clear = function () {
    this.length = 0;
};

Array.prototype.copy = function(list) {
	this.clear();
	for (var i=0;i<list.length;i++) {
		this.push(list[i]);
	}
}
        
/**
 *   Array convenience method to remove element.
 *
 *   @param object element
 *   @returns boolean
 */
Array.prototype.remove = function (element) {
        var result = false;
        var array = [];
        for (var i = 0; i < this.length; i++) {
                if (this[i] == element) {
                        result = true;
                } else {
                        array.push(this[i]);
                }
        }
        this.clear();
        for (var i = 0; i < array.length; i++) {
                this.push(array[i]);
        }
        array = null;
        return result;
};

function $(element){
	return document.getElementById(element);
}


function newCoord() {
	return {x:0,y:0};
}

function newCoordXY(valX, valY ) {
	return {x:valX,y:valY};
}
			
var colors = new Array( "empty", "yellow", "blue", "dark_blue", "orange", "rouge", "vert",  "rose", "violet",  "white",  "black");



var solution;

function rand(val) {
   /*now=new Date();
   num=(now.getSeconds())%val;*/
   var num = Math.floor ( Math.random ( ) * val)
   return num;
}

function clicked(url) 
{ 
	if (window.widget) 
	{ 
		window.widget.openURL(url); 
	} else {
		window.open(url);
	}
}


function buildChooseColor(x, y) {
	var content="<table>";
	for (var i=1;i<nbColors+1;i++) {
		if (i%4==1) {
			content+="<tr>";
		}
		content+="<td><img src='Images/"+colors[i]+".png' onclick='closeChooseColorPanel("+x+", "+y+", "+i+");'></td>";
		if (i%4==0 && i<nbColors+1) {
			content+="</tr>";
		}
	}
	content+="<td><img src='Images/empty.png' onclick='closeChooseColorPanel("+x+", "+y+", 0);'></td>";
	content+="<td><img src='Images/backbutton.png' onclick='closeChooseColorPanel("+x+", "+y+", -1);'></td></tr>";
	content+="</table>";
	$("chooseColorPanel").innerHTML=content;
}

function initGames() {
	
	$("messagePopup").style.display="none";
	if ($("solutionPieces")) {
		$("solutionPieces").innerHTML="";
	}
	$("cache").style.display="block";
	
	currentLine=0;
	win=false;
	
	if (solution) {
		solution.clear();
	} else {
		solution=new Array();
	}
	
	if (grid) {
		grid.clear();
	} else {
		
	}
	
	var fullNbColors=nbColors;
	var colorOffset=1;
	
	if (allowEmpty) {
		fullNbColors++;
		colorOffset=0;
	}
	
	//Build the solution
	var color;
	while (solution.length!=nbColumns) {
		color=rand(fullNbColors)+colorOffset;
		if (allowDoubles) {
			solution.push(color);
		} else {
			if (!solution.contains(color)) {
				solution.push(color);
			}
		}
	}
	
	drawRows();
	
	initGrid();
	
	checkGame();
}


function checkGame() {
	if (win) {
		$("message").innerHTML="<br>Congratulation !";
		$("messagePopup").style.display="block";
	} else if (currentLine>=nbRows) {
		$("message").innerHTML="<br>Try again !";
		$("messagePopup").style.display="block";
	} else {
		$("ok"+currentLine).style.display="block";
	}
}

function newLine() {
	if ($("chooseColor").style.display!="none") {
		return;
	}
	$("ok"+currentLine).style.display="none";
	
	
	var testSol=new Array();
	testSol.copy(solution);
	
	var test=new Array();
	test.copy(grid[currentLine].pieces);
	
	
	for (var i=0;i<nbColumns;i++) {
		
		if (test[i]==testSol[i]) {
			test[i]=-1;
			testSol[i]=-1;
			grid[currentLine].nbGood++;
		}
		
		
	}
	
	if (grid[currentLine].nbGood==nbColumns) {
		win=true;
	}
	
	for (var i=0;i<nbColumns;i++) {
		var indiceCol=testSol.getIndex(test[i]);
		if (test[i]!=-1 && indiceCol!=-1) {
			test[i]=-1;
			testSol[indiceCol]=-1;
			grid[currentLine].nbMove++;
		}		
	}
	
	
	
	var nbGood=grid[currentLine].nbGood;
	var nbMove=grid[currentLine].nbMove;
	
	for (var i=0;nbGood+nbMove!=0;i++) {
		if (nbGood==0 && nbMove>0) {
			$("petitepiece"+currentLine+"_"+i).src="Images/to_move.png";
			$("petitepiece"+currentLine+"_"+i).style.display="block";
			nbMove--;
		}
		if (nbGood>0) {
			$("petitepiece"+currentLine+"_"+i).src="Images/good.png";
			$("petitepiece"+currentLine+"_"+i).style.display="block";
			nbGood--;
		}
	}
	
	
	if (win) {
		drawSolution();
	}
	
	currentLine++;
	checkGame();
}


function initGrid() {
	grid=new Array();
	for (var i=0;i<nbRows;i++) {
		grid.push( {pieces:new Array(), nbGood:0, nbMove:0} );
		for (var j=0;j<nbColumns;j++) {
			grid[i].pieces.push(0);
		}
	}
}

function closeChooseColorPanel(x, y, color) {
	if (color!=-1) {
		grid[x].pieces[y]=color;
	} 
	$("piece"+x+"_"+y).src="Images/"+colors[grid[x].pieces[y]]+".png";
	$("chooseColor").style.display="none";
}

function displayChooseColorPanel(event, i, j) {
	buildChooseColor(i,j);
	
	var hauteur=342;
	var deltaY=hauteur/(nbRows);

	if (currentLine<7) {
		$("chooseColor").style.top=hauteur-48-(deltaY*(currentLine+1))+"px";
	} else {
		$("chooseColor").style.top=hauteur+48-(deltaY*(currentLine))+"px";
	}
	$("chooseColor").style.display="block";
}

function clickOnPiece(event, i,j) {
	if (i==currentLine) {
		$("piece"+i+"_"+j).src="Images/missing.png";
		displayChooseColorPanel(event, i, j);
	
		//grid[i].pieces[j]=(grid[i].pieces[j]+1)%(nbColors+1);
		//$("piece"+i+"_"+j).src="Images/"+colors[grid[i].pieces[j]]+".png";
	}
}

function drawSolution() {
	$("cache").style.display="none";
	var contentSol="";
	var largeur=148;
	var deltaX=largeur/(nbColumns+1);
	
	for (var i=0;i<nbColumns;i++) {
		contentSol+="<img id='trou"+i+"' src='Images/gros_trou.png'>";
		contentSol+="<img id='piece"+i+"' src='Images/"+colors[solution[i]]+".png''>";
	}
	$("solutionPieces").innerHTML+=contentSol;
	for (var i=0;i<nbColumns;i++) {
		$("trou"+i).style.position="absolute";
		$("trou"+i).style.bottom=16+"px";
		$("trou"+i).style.left=(deltaX*i+deltaX/2+deltaX/4)+"px";
		$("piece"+i).style.position="absolute";
		$("piece"+i).style.bottom=4+"px";
		$("piece"+i).style.left=(deltaX*i+deltaX/2-3)+"px";
		$("piece"+i).style.display="block";
	}
}

function help() {
	currentLine=nbRows;
	drawSolution();
	checkGame();
}

function drawRows() {
	var largeur=148;
	var deltaX=largeur/(nbColumns+1);
	var largeurPetit=42;
	var contentTrous="";
	var contentPetitsTrous="";
	var hauteur=342;
	var deltaY=hauteur/(nbRows);
	
	for (var i=0;i<nbRows;i++) {
		for (var j=0;j<nbColumns;j++) {
			contentTrous+="<img id='trou"+i+"_"+j+"' src='Images/gros_trou.png' onclick='clickOnPiece(event, "+i+","+j+");'>";
			contentTrous+="<img id='piece"+i+"_"+j+"' src='Images/empty.png' onclick='clickOnPiece(event, "+i+","+j+");'>";
			contentPetitsTrous+="<img id='petittrou"+i+"_"+j+"' src='Images/petit_trou.png'>";
			contentPetitsTrous+="<img id='petitepiece"+i+"_"+j+"' src='Images/petit_empty.png'>";
		}
		contentPetitsTrous+="<img id='ok"+i+"' src='Images/ok.png' onclick='newLine();'>";
	}
	
	$("trous").innerHTML=contentTrous;
	$("petitstrous").innerHTML=contentPetitsTrous;
	
	for (var i=0;i<nbRows;i++) {
		for (var j=0;j<nbColumns;j++) {
			$("trou"+i+"_"+j).style.position="absolute";
			$("trou"+i+"_"+j).style.bottom=(deltaY*i+deltaY/2-deltaY/4+4)+"px";
			$("trou"+i+"_"+j).style.left=(deltaX*j+deltaX/2+deltaX/4)+"px";
			$("piece"+i+"_"+j).style.position="absolute";
			$("piece"+i+"_"+j).style.bottom=(deltaY*i)+"px";
			$("piece"+i+"_"+j).style.left=(deltaX*j+deltaX/2-3)+"px";
		}
		
		
		
		deltaPetitX=largeurPetit/4;
		var deltaPetitY=0;
		var oriX=0;
		if (nbColumns%2 == 0) {
			oriX=5;
		}
		
		for (var j=0;j<nbColumns;j++) {
			if (nbColumns%2) {
				if (j==3) {
					deltaPetitY=-10;
					oriX=-j*deltaPetitX+deltaPetitX/2;
				} 
			} else {
				if (j==2) {
					deltaPetitY=-10;
					oriX+=-j*deltaPetitX;
				} 
			}
			$("petittrou"+i+"_"+j).style.position="absolute";
			$("petittrou"+i+"_"+j).style.bottom=(deltaY*i+deltaY/2+3+deltaPetitY)+"px";
			$("petittrou"+i+"_"+j).style.left=(deltaPetitX*j+deltaPetitX/2+deltaPetitX/4+oriX)+"px";
			$("petitepiece"+i+"_"+j).style.display="none";
			$("petitepiece"+i+"_"+j).style.position="absolute";
			$("petitepiece"+i+"_"+j).style.bottom=(deltaY*i+deltaY/2+deltaPetitY+1)+"px";
			$("petitepiece"+i+"_"+j).style.left=(deltaPetitX*j+deltaPetitX/2+deltaPetitX/4+oriX-2)+"px";
		}
		$("ok"+i).style.position="absolute";
		$("ok"+i).style.bottom=(deltaY*i+deltaY/2+3+deltaPetitY-4)+"px";
		$("ok"+i).style.left=4+"px";
		$("ok"+i).style.display="none";
		
	}
	
}

function fact(n) {
	if (n==0) return 1
	else return (n*fact(n-1))
}

function calculNbChoices() {
	var nbChoices=0;
	if (allowEmpty && allowDoubles) {
		nbChoices=Math.pow(nbColors+1,nbColumns);
	} else if (allowDoubles) {
		nbChoices=Math.pow(nbColors,nbColumns);
	} else {
		nbChoices=fact(nbColors)/fact(nbColors-nbColumns);
	}
	return nbChoices;
}
